#!/bin/sh
# concatentate multiple journal files, removing duplicate
# headers/footers and renumbering the tests into a sequential set
# 3/3/2011 Stew Benedict <stewb@linuxfoundation.org>

tnum=0

# we need:
# $journal - destination journal file
# $tcount - any "total tests" lines from the input journals
# $last - sum of the "total tests" count so we know when to stop
# from the calling script
# $1 is the input journal to be 'catted'
# test scripts can just . ./tjcat.sh

tjcat() {
  # test number replacement rules
  sedrules="s/\(^[1,8][0,5]|\)\([0,1]\) /\1$tnum /;s/\(^[2,4,5][0,1,2]0|\)\([0,1]\)\( [0,1]\) /\1$tnum $tnum /"
  # if the source file is empty, things will fall apart for sure
  if [ -s "$1" ];then 
    # 2 line header from the first journal
    if [ "$tnum" == 0 ];then
      header=`head -2 "$1"`
      echo "$header" > "$journal"
      echo "$tcount" >> "$journal"
    fi
    # throw away the 2 line header and 1 line footer, then renumber
    tail -n +3 "$1" | head -n -1 | grep -v "total tests" | sed "$sedrules" >> "$journal"
    tnum=`expr $tnum + 1`
    # footer from the last journal
    if [ "$tnum" == "$last" ];then
      tail -1 "$1" >> "$journal"
    fi
  fi
  rm -f "$1"
}
